/*
 File: linker_pass3sym.cpp
 Date and Time: Fri Jan 30 18:55:14 2015 
*/
#include "linker_pass3.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_linker_pass3;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Clinker_pass3::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rlinker_pass3_:{
       Rlinker_pass3* sym;
     if(re->rule_ == 0){
       sym = new Rlinker_pass3(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlinker_pass3*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 15;
    

     sym->op();
     return;}
    case rhs1_RT_alphabet_:{
       RT_alphabet* sym;
     if(re->rule_ == 0){
       sym = new RT_alphabet(parser__);
       re->rule_ = sym;
     }else{
       sym = (RT_alphabet*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_RT_alphabet_:{
       RT_alphabet* sym;
     if(re->rule_ == 0){
       sym = new RT_alphabet(parser__);
       re->rule_ = sym;
     }else{
       sym = (RT_alphabet*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_RT_alphabet_:{
       RT_alphabet* sym;
     if(re->rule_ == 0){
       sym = new RT_alphabet(parser__);
       re->rule_ = sym;
     }else{
       sym = (RT_alphabet*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_RT_alphabet_filename_:{
       RT_alphabet_filename* sym;
     if(re->rule_ == 0){
       sym = new RT_alphabet_filename(parser__);
       re->rule_ = sym;
     }else{
       sym = (RT_alphabet_filename*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_RT_alphabet_filename_:{
       RT_alphabet_filename* sym;
     if(re->rule_ == 0){
       sym = new RT_alphabet_filename(parser__);
       re->rule_ = sym;
     }else{
       sym = (RT_alphabet_filename*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_RT_alphabet_filename_:{
       RT_alphabet_filename* sym;
     if(re->rule_ == 0){
       sym = new RT_alphabet_filename(parser__);
       re->rule_ = sym;
     }else{
       sym = (RT_alphabet_filename*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_RT_alphabet_filename_:{
       RT_alphabet_filename* sym;
     if(re->rule_ == 0){
       sym = new RT_alphabet_filename(parser__);
       re->rule_ = sym;
     }else{
       sym = (RT_alphabet_filename*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    case rhs5_RT_alphabet_filename_:{
       RT_alphabet_filename* sym;
     if(re->rule_ == 0){
       sym = new RT_alphabet_filename(parser__);
       re->rule_ = sym;
     }else{
       sym = (RT_alphabet_filename*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr5();
     return;}
    case rhs6_RT_alphabet_filename_:{
       RT_alphabet_filename* sym;
     if(re->rule_ == 0){
       sym = new RT_alphabet_filename(parser__);
       re->rule_ = sym;
     }else{
       sym = (RT_alphabet_filename*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr6();
     return;}
    case rhs1_Remitfile_:{
       Remitfile* sym;
     if(re->rule_ == 0){
       sym = new Remitfile(parser__);
       re->rule_ = sym;
     }else{
       sym = (Remitfile*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Remitfile_:{
       Remitfile* sym;
     if(re->rule_ == 0){
       sym = new Remitfile(parser__);
       re->rule_ = sym;
     }else{
       sym = (Remitfile*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Remitfile_:{
       Remitfile* sym;
     if(re->rule_ == 0){
       sym = new Remitfile(parser__);
       re->rule_ = sym;
     }else{
       sym = (Remitfile*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_Remitfile_filename_:{
       Remitfile_filename* sym;
     if(re->rule_ == 0){
       sym = new Remitfile_filename(parser__);
       re->rule_ = sym;
     }else{
       sym = (Remitfile_filename*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Remitfile_filename_:{
       Remitfile_filename* sym;
     if(re->rule_ == 0){
       sym = new Remitfile_filename(parser__);
       re->rule_ = sym;
     }else{
       sym = (Remitfile_filename*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Remitfile_filename_:{
       Remitfile_filename* sym;
     if(re->rule_ == 0){
       sym = new Remitfile_filename(parser__);
       re->rule_ = sym;
     }else{
       sym = (Remitfile_filename*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Remitfile_filename_:{
       Remitfile_filename* sym;
     if(re->rule_ == 0){
       sym = new Remitfile_filename(parser__);
       re->rule_ = sym;
     }else{
       sym = (Remitfile_filename*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    case rhs5_Remitfile_filename_:{
       Remitfile_filename* sym;
     if(re->rule_ == 0){
       sym = new Remitfile_filename(parser__);
       re->rule_ = sym;
     }else{
       sym = (Remitfile_filename*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr5();
     return;}
    case rhs6_Remitfile_filename_:{
       Remitfile_filename* sym;
     if(re->rule_ == 0){
       sym = new Remitfile_filename(parser__);
       re->rule_ = sym;
     }else{
       sym = (Remitfile_filename*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr6();
     return;}
    case rhs1_Rpreamble_:{
       Rpreamble* sym;
     if(re->rule_ == 0){
       sym = new Rpreamble(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpreamble*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rpreamble_:{
       Rpreamble* sym;
     if(re->rule_ == 0){
       sym = new Rpreamble(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpreamble*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rpreamble_:{
       Rpreamble* sym;
     if(re->rule_ == 0){
       sym = new Rpreamble(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpreamble*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_Rpreamble_code_:{
       Rpreamble_code* sym;
     if(re->rule_ == 0){
       sym = new Rpreamble_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpreamble_code*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rpreamble_code_:{
       Rpreamble_code* sym;
     if(re->rule_ == 0){
       sym = new Rpreamble_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpreamble_code*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rpreamble_code_:{
       Rpreamble_code* sym;
     if(re->rule_ == 0){
       sym = new Rpreamble_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpreamble_code*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_R_fsc_files_:{
       R_fsc_files* sym;
     if(re->rule_ == 0){
       sym = new R_fsc_files(parser__);
       re->rule_ = sym;
     }else{
       sym = (R_fsc_files*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_R_fsc_files_:{
       R_fsc_files* sym;
     if(re->rule_ == 0){
       sym = new R_fsc_files(parser__);
       re->rule_ = sym;
     }else{
       sym = (R_fsc_files*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs3_R_fsc_files_:{
       R_fsc_files* sym;
     if(re->rule_ == 0){
       sym = new R_fsc_files(parser__);
       re->rule_ = sym;
     }else{
       sym = (R_fsc_files*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_R_fsc_file_:{
       R_fsc_file* sym;
     if(re->rule_ == 0){
       sym = new R_fsc_file(parser__);
       re->rule_ = sym;
     }else{
       sym = (R_fsc_file*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_R_fsc_file_:{
       R_fsc_file* sym;
     if(re->rule_ == 0){
       sym = new R_fsc_file(parser__);
       re->rule_ = sym;
     }else{
       sym = (R_fsc_file*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_R_fsc_file_:{
       R_fsc_file* sym;
     if(re->rule_ == 0){
       sym = new R_fsc_file(parser__);
       re->rule_ = sym;
     }else{
       sym = (R_fsc_file*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_R_fsc_file_:{
       R_fsc_file* sym;
     if(re->rule_ == 0){
       sym = new R_fsc_file(parser__);
       re->rule_ = sym;
     }else{
       sym = (R_fsc_file*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    case rhs5_R_fsc_file_:{
       R_fsc_file* sym;
     if(re->rule_ == 0){
       sym = new R_fsc_file(parser__);
       re->rule_ = sym;
     }else{
       sym = (R_fsc_file*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr5();
     return;}
    case rhs1_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    default: return;
   }
}
